Index: /trunk/wp-admin/css/global.css
===================================================================
--- /trunk/wp-admin/css/global.css	(revision 7501)
+++ /trunk/wp-admin/css/global.css	(revision 7502)
@@ -37,4 +37,45 @@
 .hidden { display: none; }
 
+h1 {
+  display: block;
+  font-size: 2em;
+  font-weight: bold;
+  margin: .67em 0;
+}
+
+h2 {
+  display: block;
+  font-size: 1.5em;
+  font-weight: bold;
+  margin: .83em 0;
+}
+
+h3 {
+  display: block;
+  font-size: 1.17em;
+  font-weight: bold;
+  margin: 1em 0;
+}
+
+h4 {
+  display: block;
+  font-weight: bold;
+  margin: 1.33em 0;
+}
+
+h5 {
+  display: block;
+  font-size: 0.83em;
+  font-weight: bold;
+  margin: 1.67em 0;
+}
+
+h6 {
+  display: block;
+  font-size: 0.67em;
+  font-weight: bold;
+  margin: 2.33em 0;
+}
+
 .subsubsub {
 	list-style: none;
@@ -73,10 +114,14 @@
 	border-bottom-color: #ccc;
 	font-size: 11px;
-	padding: 7px 25px 6px 2px;
 	vertical-align: text-top;
 }
 
+.widefat td {
+	padding: 7px 15px 6px 10px;
+	vertical-align: top;
+}
+
 .widefat th {
-	padding: 9px 25px 4px 2px;
+	padding: 9px 15px 6px 10px;
 	text-align: left;
 	line-height: 1.3em;
@@ -84,21 +129,25 @@
 
 .widefat th input {
-	margin: 0 3px;
+	margin: 0 0 0 8px;
 	padding: 0;
 }
 
 .widefat .check-column {
-	text-align: center;
-	width: 1.8em;
-	padding: 9px 2px 6px 6px;
+	text-align: right;
+	width: 1.5em;
+	padding: 0;
+
 }
 
 .widefat tbody th.check-column {
-	padding-bottom: 20px;
+	padding: 8px 0 22px;
 }
-
+/*
+th.check-column + th, th.check-column + td {
+	padding-left: 5px;
+}
+*/
 .widefat .num {
 	text-align: center;
-	padding: 10px 16px 0;
 }
 
Index: /trunk/wp-admin/css/ie.css
===================================================================
--- /trunk/wp-admin/css/ie.css	(revision 7501)
+++ /trunk/wp-admin/css/ie.css	(revision 7502)
@@ -32,5 +32,5 @@
 }
 
-#wpwrap, #wpcontent, #post, #wrap, #postdivrich, #postdiv, #poststuff, #titlediv, #post-body, #editorcontainer, .tablenav, .widget-control-list {
+#wpwrap, #wpcontent, #post, #wrap, #postdivrich, #postdiv, #poststuff, #titlediv, #post-body, #editorcontainer, .tablenav, .widget-control-list, li.widget-list-control-item, #dragHelper, li.widget-list-control-item h4, .widget-sortable, .widget-control-actions {
 	display: block;
 	zoom: 100%;
@@ -93,9 +93,5 @@
 }
 
-* html .tablenav {
-
-}
-
-.tablenav .button-secondary {
+.tablenav .button-secondary, .nav .button-secondary {
 	padding: 0 1px;
 	vertical-align: middle;
@@ -124,20 +120,22 @@
 
 .widefat tr, .widefat th {
-	padding: 13px 25px 0 2px;
 	margin-bottom: 0;
 	border-spacing: 0;
 }
 
-.widefat thead th.check-column {
-	padding: 9px 2px 4px 3px;
+.widefat th input {
+	margin: 0 0 0 5px;
+}
+
+.widefat .check-column {
+	padding: 6px 0 2px;
 }
 
 .widefat tbody th.check-column {
-	padding: 4px 3px 22px 3px;
-	text-align:center;
-	width:1.8em;
+	padding: 4px 0 22px;
 }
 
-.widefat th.num {
-	padding: 14px 16px 0;
+.tablenav a.button-secondary {
+	display: inline-block;
+	padding: 2px 5px;
 }
Index: /trunk/wp-admin/css/widgets.css
===================================================================
--- /trunk/wp-admin/css/widgets.css	(revision 7501)
+++ /trunk/wp-admin/css/widgets.css	(revision 7502)
@@ -8,5 +8,5 @@
 
 div.widget-liquid-left {
-	margin-right: 310px;
+	margin-right: 320px;
 }
 
@@ -42,5 +42,5 @@
 
 ul#widget-list li.widget-list-item {
-	padding: .7em 1em;
+	padding: .7em 0.9em;
 	margin: 0;
 	border-bottom-width: 1px;
@@ -56,4 +56,5 @@
 	width: 200px;
 	float: left;
+	font-size: 13px;
 	-moz-border-radius: 3px;
 	-khtml-border-radius: 3px;
@@ -103,7 +104,9 @@
 }
 
-li.widget-list-control-item h4, #dragHelper li.widget-list-control-item h4 {
+li.widget-list-control-item h4, #dragHelper li.widget-list-control-item h4, li.widget-sortable h4 {
 	margin: 0;
-	padding: .5em 1em;
+	padding: 0.4em 2.5em 0.4em 0.8em;
+	cursor: move;
+	font-size: 13px;
 	-moz-border-radius: 3px;
 	-khtml-border-radius: 3px;
@@ -113,5 +116,5 @@
 
 .widget-control-save, .widget-control-remove {
-	padding: 4px 6px;
+	padding: 3px 5px;
 	-moz-border-radius: 3px;
 	-khtml-border-radius: 3px;
@@ -145,5 +148,5 @@
 	display: none;
 	margin: 1em;
-	padding: 0 10px 0 0; /* Correction for padding, margin, border of inputs */
+	padding: 0 10px 0 7px; /* Correction for padding, margin, border of inputs */
 	font-size: 11px;
 }
@@ -156,13 +159,12 @@
 ul.widget-control-list div.widget-control-actions {
 	margin-right: -10px; /* Correction for padding, margin, border of inputs */
-	padding: 0 0 1em;
+	margin-left: -6px;
 	border-top-width: 1px;
 	border-top-style: solid;
-	padding: 0.5em 0 1em 0;
+	padding: 0.5em 0 0.8em;
 }
 
 ul.widget-control-list .widget-title {
-	cursor: move;
-	font-size: 12px;
+	
 }
 
@@ -172,11 +174,17 @@
 }
 
-
 div#current-widgets {
 	padding-top: 1em;
 	border-width: 1px;
-	border-style: solid;
-	borde-right-style: none;
-	border-left-style: none;
+	border-style: solid none none;
 }
 
+#widget-controls .widefat {
+	width: 92%;
+	padding: 3px;
+}
+
+#widget-controls select.widefat {
+	width: auto;
+	display: block;
+}
Index: /trunk/wp-admin/wp-admin.css
===================================================================
--- /trunk/wp-admin/wp-admin.css	(revision 7501)
+++ /trunk/wp-admin/wp-admin.css	(revision 7502)
@@ -171,9 +171,12 @@
 }
 
-select {
-	font: 12px/14px "Lucida Grande", "Lucida Sans Unicode", Tahoma, Verdana, sans-serif;
-	padding: 0;
-	border-width: 1px;
-	border-style: solid;
+#wpcontent select {
+	font: 12px/20px "Lucida Grande", "Lucida Sans Unicode", Tahoma, Verdana, sans-serif;
+	padding: 2px;
+
+	border-width: 1px;
+	border-style: solid;
+	height: 2em;
+	vertical-align:top;
 }
 
@@ -433,6 +436,12 @@
 
 div.nav {
-	padding: 0.7em 1em;
-	margin: .7em 0;
+	height: 2em;
+	padding: 7px 10px;
+	vertical-align: text-top;
+	margin: 5px 0;
+}
+
+.nav .button-secondary {
+	padding: 2px 4px;
 }
 
@@ -469,25 +478,12 @@
 }
 
-.tablenav select {
-	padding: 2px;
-	display: inline-block;
-	line-height: 2;
-	height: 2em;
-
-}
-
-.tablenav option {
-	margin: 3px;
-	display: inline-block;
-}
-
 .tablenav a.button-secondary {
-	display: inline-block;
-	margin-right: 8px;
+	display: block;
+	margin: 1px 8px 0 0;
 }
 
 .tablenav .button-secondary {
 	padding: 2px 4px;
-
+	vertical-align: top;
 }
 
@@ -502,4 +498,5 @@
 	margin-bottom: -10px;
 	margin-top: 8px;
+	vertical-align: text-top;
 }
 
@@ -742,5 +739,5 @@
 
 strong .post-com-count {
-	background-position: center -56px;
+	background-position: center -55px;
 }
 
@@ -1413,4 +1410,8 @@
 }
 
+#the-comment-list .check-column {
+	padding-top: 8px;
+}
+
 #templateside ul li a {
 	text-decoration: none;
Index: /trunk/wp-includes/js/tinymce/themes/advanced/link.htm
===================================================================
--- /trunk/wp-includes/js/tinymce/themes/advanced/link.htm	(revision 7501)
+++ /trunk/wp-includes/js/tinymce/themes/advanced/link.htm	(revision 7502)
@@ -26,5 +26,5 @@
             <td><table border="0" cellspacing="0" cellpadding="0"> 
 				  <tr> 
-					<td><input id="href" name="href" type="text" class="mceFocus" value="" style="width: 200px" onchange="LinkDialog.checkPrefix(this);" /></td> 
+					<td><input id="href" name="href" type="text" class="mceFocus" value="http://" style="width: 200px" /></td> 
 					<td id="hrefbrowsercontainer">&nbsp;</td>
 				  </tr> 