Index: /trunk/wp-includes/link-template.php
===================================================================
--- /trunk/wp-includes/link-template.php	(revision 9631)
+++ /trunk/wp-includes/link-template.php	(revision 9632)
@@ -1055,36 +1055,58 @@
 
 /**
- * Display the next posts pages link.
+ * Display or return the next posts pages link.
  *
  * @since 0.71
  *
  * @param int $max_page Optional. Max pages.
- */
-function next_posts($max_page = 0) {
-	echo clean_url(get_next_posts_page_link($max_page));
-}
-
-/**
- * Display the next posts pages link.
- *
- * @since 0.71
+ * @param boolean $echo Optional. Echo or return;
+ */
+function next_posts( $max_page = 0, $echo = true ) {
+	$output = clean_url( get_next_posts_page_link( $max_page ) );
+
+	if ( $echo )
+		echo $output;
+	else
+		return $output;
+}
+
+/**
+ * Return the next posts pages link.
+ *
+ * @since 2.7.0
  *
  * @param string $label Content for link text.
  * @param int $max_page Optional. Max pages.
- */
-function next_posts_link($label='Next Page &raquo;', $max_page=0) {
+ * @return string|null
+ */
+function get_next_posts_link( $label = 'Next Page &raquo;', $max_page = 0 ) {
 	global $paged, $wp_query;
+
 	if ( !$max_page ) {
 		$max_page = $wp_query->max_num_pages;
 	}
+
 	if ( !$paged )
 		$paged = 1;
+
 	$nextpage = intval($paged) + 1;
-	if ( (! is_single()) && (empty($paged) || $nextpage <= $max_page) ) {
-		echo '<a href="';
-		next_posts($max_page);
+
+	if ( !is_single() && ( empty($paged) || $nextpage <= $max_page) ) {
 		$attr = apply_filters( 'next_posts_link_attributes', '' );
-		echo "\" $attr>". preg_replace('/&([^#])(?![a-z]{1,8};)/', '&#038;$1', $label) .'</a>';
-	}
+		return '<a href="' . next_posts( $max_page, false ) . "\" $attr>". preg_replace('/&([^#])(?![a-z]{1,8};)/', '&#038;$1', $label) .'</a>';
+	}
+}
+
+/**
+ * Display the next posts pages link.
+ *
+ * @since 0.71
+ * @uses get_next_posts_link()
+ *
+ * @param string $label Content for link text.
+ * @param int $max_page Optional. Max pages.
+ */
+function next_posts_link( $label = 'Next Page &raquo;', $max_page = 0 ) {
+	echo get_next_posts_link( $label, $max_page );
 }
 
@@ -1112,27 +1134,46 @@
 
 /**
- * Display previous posts pages link.
+ * Display or return the previous posts pages link.
  *
  * @since 0.71
- */
-function previous_posts() {
-	echo clean_url(get_previous_posts_page_link());
-}
-
-/**
- * Display previous posts page link.
+ *
+ * @param boolean $echo Optional. Echo or return;
+ */
+function previous_posts( $echo = true ) {
+	$output = clean_url( get_previous_posts_page_link() );
+
+	if ( $echo )
+		echo $output;
+	else
+		return $output;
+}
+
+/**
+ * Return the previous posts pages link.
+ *
+ * @since 2.7.0
+ *
+ * @param string $label Optional. Previous page link text.
+ * @return string|null
+ */
+function get_previous_posts_link( $label = '&laquo; Previous Page' ) {
+	global $paged;
+
+	if ( !is_single() && $paged > 1 ) {
+		$attr = apply_filters( 'previous_posts_link_attributes', '' );
+		return '<a href="' . previous_posts( false ) . "\" $attr>". preg_replace( '/&([^#])(?![a-z]{1,8};)/', '&#038;$1', $label ) .'</a>';
+	}
+}
+
+/**
+ * Display the previous posts page link.
  *
  * @since 0.71
+ * @uses get_previous_posts_link()
  *
  * @param string $label Optional. Previous page link text.
  */
-function previous_posts_link($label='&laquo; Previous Page') {
-	global $paged;
-	if ( (!is_single())	&& ($paged > 1) ) {
-		echo '<a href="';
-		previous_posts();
-		$attr = apply_filters( 'previous_posts_link_attributes', '' );
-		echo "\" $attr>". preg_replace('/&([^#])(?![a-z]{1,8};)/', '&#038;$1', $label) .'</a>';
-	}
+function previous_posts_link( $label = '&laquo; Previous Page' ) {
+	echo get_previous_posts_link( $label );
 }
 
@@ -1146,5 +1187,5 @@
  * @param string $nxtlabel Optional Label for next pages.
  */
-function posts_nav_link($sep=' &#8212; ', $prelabel='&laquo; Previous Page', $nxtlabel='Next Page &raquo;') {
+function posts_nav_link( $sep = ' &#8212; ', $prelabel = '&laquo; Previous Page', $nxtlabel = 'Next Page &raquo;' ) {
 	global $wp_query;
 	if ( !is_singular() ) {