Index: /trunk/wp-admin/admin.php
===================================================================
--- /trunk/wp-admin/admin.php	(revision 9978)
+++ /trunk/wp-admin/admin.php	(revision 9979)
@@ -39,5 +39,5 @@
 wp_reset_vars(array('profile', 'redirect', 'redirect_url', 'a', 'popuptitle', 'popupurl', 'text', 'trackback', 'pingback'));
 
-wp_admin_css_color('classic', __('Blue'), admin_url("css/colors-classic.css"), array('#073447', '#6D6D6D', '#F1F1F1', '#DFDFDF'));
+wp_admin_css_color('classic', __('Blue'), admin_url("css/colors-classic.css"), array('#073447', '#21759B', '#EAF3FA', '#BBD8E7'));
 wp_admin_css_color('fresh', __('Gray'), admin_url("css/colors-fresh.css"), array('#464646', '#6D6D6D', '#F1F1F1', '#DFDFDF'));
 
Index: /trunk/wp-admin/css/colors-classic.css
===================================================================
--- /trunk/wp-admin/css/colors-classic.css	(revision 9978)
+++ /trunk/wp-admin/css/colors-classic.css	(revision 9979)
@@ -1,4 +1,4 @@
 html {
-	background-color: #f9f9f9;
+	background-color: #F5FCFD;
 }
 
@@ -72,5 +72,5 @@
 
 .widefat {
-	border-color: #dfdfdf;
+	border-color: #BBD8E7;
 	background-color: #fff;
 }
@@ -118,7 +118,8 @@
 }
 
-#poststuff h3,
-.metabox-holder h3 {
-	background-color: #dfdfdf;
+.metabox-holder .postbox h3,
+#poststuff .postbox h3,
+#poststuff .stuffbox h3 {
+	background: #dfdfdf url("../images/blue-grad.png") repeat-x left top;
 	text-shadow: #fff 0 1px 0;
 }
@@ -174,5 +175,5 @@
 
 .alternate, .alt {
-	background-color: #f9f9f9;
+	background-color: #EDFBFC;
 }
 
@@ -435,5 +436,9 @@
 .widefat td,
 .widefat th {
-	border-color: #dfdfdf;
+	border-bottom-color: #BBD8E7;
+}
+
+.widefat th {
+	text-shadow: rgba(255,255,255,0.8) 0 1px 0;
 }
 
@@ -447,5 +452,5 @@
 .find-box-head {
 	color: #333;
-	background: #dfdfdf url(../images/gray-grad.png) repeat-x scroll left top;
+	background: #dfdfdf url(../images/blue-grad.png) repeat-x scroll left top;
 }
 
@@ -465,5 +470,5 @@
 #media-upload a.delete,
 .ui-tabs-nav a, a {
-	color: #21759b;
+	color: #1C6280;
 }
 
@@ -626,5 +631,5 @@
 .stuffbox input[type="text"],
 .stuffbox textarea {
-	border-color: #dfdfdf;
+	border-color: #BBD8E7;
 }
 
@@ -1011,5 +1016,5 @@
 
 #adminmenu a.menu-top {
-	background: #f1f1f1 url(../images/menu-bits.gif) repeat-x scroll left -379px;
+	background: #EAF3FA url(../images/menu-bits.gif) repeat-x scroll left -379px;
 }
 
@@ -1076,15 +1081,15 @@
 .folded #adminmenu li.menu-top,
 #adminmenu .wp-submenu .wp-submenu-head {
-	background-color: #F1F1F1;
+	background-color: #EAF2FA;
 }
 
 .folded #adminmenu li.wp-has-current-submenu,
 .folded #adminmenu li.menu-top.current {
-	background-color: #eaeaea;
+	background-color: #BBD8E7;
 }
 
 #adminmenu .wp-has-current-submenu .wp-submenu .wp-submenu-head {
-	background-color: #EAEAEA;
-	border-color: #aaa;
+	background-color: #BBD8E7;
+	border-color: #8CBDD5;
 }
 
@@ -1486,8 +1491,4 @@
 }
 
-.widefat th {
-	text-shadow: rgba(255,255,255,0.8) 0 1px 0;
-}
-
 #wphead h1 {
 	text-shadow: rgba(0,0,0,0.6) 0 -1px 0;
Index: /trunk/wp-admin/css/colors-fresh.css
===================================================================
--- /trunk/wp-admin/css/colors-fresh.css	(revision 9978)
+++ /trunk/wp-admin/css/colors-fresh.css	(revision 9979)
@@ -112,15 +112,4 @@
 	color: #fff;
 }
-/*
-li.widget-list-control-item,
-div.nav,
-#dashboard-widgets p.dashboard-widget-links,
-#replyhandle,
-h3.info-box-title,
-#screen-options-wrap,
-#wpbody-content .describe tr {
-	background-color: #eaf3fa;
-}
-*/
 
 li.widget-list-control-item div.widget-control {
@@ -129,7 +118,8 @@
 }
 
-#poststuff h3,
-.metabox-holder h3 {
-	background-color: #dfdfdf;
+.metabox-holder .postbox h3,
+#poststuff .postbox h3,
+#poststuff .stuffbox h3 {
+	background: #dfdfdf url("../images/gray-grad.png") repeat-x left top;
 	text-shadow: #fff 0 1px 0;
 }
@@ -458,4 +448,8 @@
 }
 
+.widefat th {
+	text-shadow: rgba(255,255,255,0.8) 0 1px 0;
+}
+
 .widefat thead tr,
 .widefat tfoot tr,
@@ -694,38 +688,5 @@
 	color: #555;
 }
-/*
-#upload-files a.file-link {
-	background-color: #d1e2ef;
-}
-
-#upload-file-view a img {
-	border-bottom-color: #69c;
-}
-
-#upload-menu li #current-tab-nav,
-#upload-file {
-	background-color: #f9fcfe;
-}
-
-#upload-menu li span a.page-numbers {
-	color: #00019b;
-}
-
-#upload-menu li.current {
-	border-right-color: #448abd;
-	color: #000;
-}
-
-#upload-menu li.current a.upload-tab-link,
-#upload-menu li a:hover {
-	background-color: #f9fcfe;
-	color: #000;
-}
-
-#upload-menu,
-#upload-menu li {
-	border-top-color: #247fab;
-}
-*/
+
 .login #backtoblog a {
 	color: #ccc;
@@ -1134,5 +1095,5 @@
 .folded #adminmenu li.wp-has-current-submenu,
 .folded #adminmenu li.menu-top.current {
-	background-color: #eaeaea;
+	background-color: #e6e6e6;
 }
 
@@ -1539,8 +1500,4 @@
 }
 
-.widefat th {
-	text-shadow: rgba(255,255,255,0.8) 0 1px 0;
-}
-
 #wphead h1 {
 	text-shadow: rgba(0,0,0,0.6) 0 -1px 0;
Index: /trunk/wp-admin/gears-manifest.php
===================================================================
--- /trunk/wp-admin/gears-manifest.php	(revision 9978)
+++ /trunk/wp-admin/gears-manifest.php	(revision 9979)
@@ -138,4 +138,5 @@
 { "url" : "images/align-right.png" },
 { "url" : "images/archive-link.png" },
+{ "url" : "images/blue-grad.png" },
 { "url" : "images/browse-happy.gif" },
 { "url" : "images/bubble_bg.gif" },
@@ -175,5 +176,4 @@
 { "url" : "images/menu-dark-rtl.gif" },
 { "url" : "images/no.png" },
-{ "url" : "images/postbox-bg.gif" },
 { "url" : "images/required.gif" },
 { "url" : "images/resize.gif" },
Index: /trunk/wp-admin/wp-admin.css
===================================================================
--- /trunk/wp-admin/wp-admin.css	(revision 9978)
+++ /trunk/wp-admin/wp-admin.css	(revision 9979)
@@ -1625,7 +1625,4 @@
 #poststuff .postbox h3,
 #poststuff .stuffbox h3 {
-	background-image: url("images/postbox-bg.gif");
-	background-position: left top;
-	background-repeat: repeat-x;
 	-moz-border-radius: 6px 6px 0 0;
 	-webkit-border-top-right-radius: 6px;
Index: /trunk/wp-includes/script-loader.php
===================================================================
--- /trunk/wp-includes/script-loader.php	(revision 9978)
+++ /trunk/wp-includes/script-loader.php	(revision 9979)
@@ -309,5 +309,5 @@
 	$styles->add_data( 'ie', 'conditional', 'gte IE 6' );
 
-	$styles->add( 'colors', true, array(), '20081129' ); // Register "meta" stylesheet for admin colors
+	$styles->add( 'colors', true, array(), '20081130' ); // Register "meta" stylesheet for admin colors
 	$styles->add( 'colors-fresh', '/wp-admin/css/colors-fresh.css', array(), '20081129'); // for login.php.  Is there a better way?
 	$styles->add_data( 'colors-fresh', 'rtl', true );